#include "vector.h"
#include <iostream>
using namespace std;


ostream& operator << (ostream& s, const Vector& v) {
	s << "[";
	
	if(v.getSize() > 0) {
		s << v[0];
	}

	for(int i = 1; i < v.getSize(); ++i) {
		s << ", " << v[i];
	}

	return s << "]";
}

int main() {

	Vector v = 0;

	// Създаваме вектор [1, 5, 2, 3, 1]
	cout << v.insert(1).insert(5).insert(2).insert(3).insert(1) << endl;

	// Резултат: [1, 2, 3, 1]
	cout << v.removeAt(1) << endl;

	// Резултат: [1, 2, 3, 4, 1, 6]
	cout << v.insertAt(4, 3).insert(6) << endl;

	// Резултат [1, 2, 3, 4, 5]
	v.remove()[4] = 5;
	cout << v << endl;

	{
		Vector v1 = v;
		v1.insert(7);
		cout << v1 << endl;
	}
	// Деструкторът ще се извика тук (за v1)

	// Резултат: [1, 2, 3]
	cout << v.remove().remove() << endl;
}
// Деструкторът ще се извика и тук (за v)
